## wildfly:run

Full name:

org.wildfly.plugins:wildfly-maven-plugin:5.1.0.Alpha1:run

Description:

Starts a standalone instance of WildFly and deploys the application to the server.

This goal will block until cancelled or a shutdown is invoked from a management client.

Note that if a WildFly Bootable JAR is packaged, it is ignored by this goal.

Attributes:

- Requires a Maven project to be executed.
- Requires dependency resolution of artifacts in scope: `runtime`.
- The goal is not marked as thread-safe and thus does not support parallel builds.
- Invokes the execution of the following lifecycle phase prior to executing itself: `package`.

### Optional Parameters

Name | Type | Since | Description
--- | --- | --- | ---
`<addUser>` | `AddUser` | `-` | The users to add to the server. User Property: `wildfly.add-user` Alias: `add-user`
`<authenticationConfig>` | `URL` | `-` | A URL which points to the authentication configuration (`wildfly-config.xml`) the client uses to authenticate with the server. User Property: `wildfly.authConfig` Alias: `authentication-config`
`<commands>` | `List<String>` | `-` | The CLI commands to execute before the deployment is deployed. User Property: `wildfly.commands`
`<debug>` | `boolean` | `-` | Starts the server with debugging enabled. Default: `false` User Property: `wildfly.debug`
`<debugHost>` | `String` | `-` | Sets the hostname to listen on for debugging. An `*` means all hosts. Default: `*` User Property: `wildfly.debug.host`
`<debugPort>` | `int` | `-` | Sets the port the debugger should listen on. Default: `8787` User Property: `wildfly.debug.port`
`<debugSuspend>` | `boolean` | `-` | Indicates whether the server should suspend itself until a debugger is attached. Default: `false` User Property: `wildfly.debug.suspend`
`<env>` | `Map<String,String>` | `-` | Specifies the environment variables to be passed to the process being started.
    <env>
        <HOME>/home/wildfly/</HOME>
    </env>
`<featurePackLocation>` | `String` | `-` | The feature pack location. See the documentation for details on how to format a feature pack location. Note that if you define the version in the feature pack location, e.g. `#26.1.1.Final`, the `version` configuration parameter should be left blank. User Property: `wildfly.feature-pack.location` Alias: `feature-pack-location`
`<filename>` | `String` | `-` | The file name of the application to be deployed. The `filename` property does have a default of `${project.build.finalName}.${project.packaging}`. The default value is not injected as it normally would be due to packaging types like `ejb` that result in a file with a `.jar` extension rather than an `.ejb` extension. User Property: `wildfly.deployment.filename`
`<hostname>` | `String` | `-` | Specifies the host name of the server where the deployment plan should be executed. Default: `localhost` User Property: `wildfly.hostname`
`<id>` | `String` | `-` | Specifies the id of the server if the username and password is to be retrieved from the settings.xml file User Property: `wildfly.id`
`<javaHome>` | `String` | `-` | The `JAVA_HOME` to use for launching the server. User Property: `java.home` Alias: `java-home`
`<javaOpts>` | `String[]` | `-` | The JVM options to use. User Property: `wildfly.javaOpts` Alias: `java-opts`
`<jbossHome>` | `String` | `-` | The WildFly Application Server's home directory. If not used, WildFly will be downloaded. User Property: `jboss-as.home` Alias: `jboss-home`
`<moduleOptions>` | `String[]` | `-` | Options passed to JBoss Modules. This is useful for things like Java Agents where you need to start the server with an agent. User Property: `wildfly.moduleOptions` Alias: `module-options`
`<modulesPath>` | `ModulesPath` | `-` | The modules path or paths to use. A single path can be used or multiple paths by enclosing them in a paths element. User Property: `wildfly.modulesPath` Alias: `modules-path`
`<name>` | `String` | `-` | Specifies the name used for the deployment. User Property: `wildfly.deployment.name`
`<password>` | `String` | `-` | Specifies the password to use if prompted to authenticate by the server. If no password is specified and the server requests authentication the user will be prompted to supply the password, User Property: `wildfly.password`
`<port>` | `int` | `-` | Specifies the port number the server is listening on. Default: `9990` User Property: `wildfly.port`
`<propertiesFile>` | `String` | `-` | The path to the system properties file to load. User Property: `wildfly.propertiesFile` Alias: `properties-file`
`<protocol>` | `String` | `-` | The protocol used to connect to the server for management. User Property: `wildfly.protocol`
`<provisioningDir>` | `String` | `3.0` | The directory name inside the buildDir where to provision the default server. By default the server is provisioned into the 'server' directory. Default: `server` User Property: `wildfly.provisioning.dir` Alias: `provisioning-dir`
`<runtimeName>` | `String` | `-` | The runtime name for the deployment. In some cases users may wish to have two deployments with the same `runtime-name` (e.g. two versions of `example.war`) both available in the management configuration, in which case the deployments would need to have distinct `name` values but would have the same `runtime-name`. User Property: `wildfly.deployment.runtime.name` Alias: `runtime-name`
`<scripts>` | `List<File>` | `-` | The CLI script files to execute before the deployment is deployed. User Property: `wildfly.scripts`
`<serverArgs>` | `String[]` | `-` | The arguments to be passed to the server. User Property: `wildfly.serverArgs` Alias: `server-args`
`<serverConfig>` | `String` | `-` | The path to the server configuration to use. User Property: `wildfly.serverConfig` Alias: `server-config`
`<skip>` | `boolean` | `-` | Set to `true` if you want to skip this goal, otherwise `false`. Default: `false` User Property: `wildfly.skip`
`<startupTimeout>` | `long` | `-` | The timeout value to use when starting the server. Default: `60` User Property: `wildfly.startupTimeout` Alias: `startup-timeout`
`<timeout>` | `int` | `-` | The timeout, in seconds, to wait for a management connection. Default: `60` User Property: `wildfly.timeout`
`<username>` | `String` | `-` | Specifies the username to use if prompted to authenticate by the server. If no username is specified and the server requests authentication the user will be prompted to supply the username, User Property: `wildfly.username`
`<version>` | `String` | `-` | The version of the WildFly default server to install in case no jboss-home has been set and no server has previously been provisioned. The latest stable version is resolved if left blank. User Property: `wildfly.version`

### Parameter Details

#### <addUser>

The users to add to the server.

- Type: `org.wildfly.plugin.server.AddUser`
- Required: `No`
- User Property: `wildfly.add-user`
- Alias: `add-user`

#### <authenticationConfig>

A URL which points to the authentication configuration (`wildfly-config.xml`) the client uses to authenticate with the server.

- Type: `java.net.URL`
- Required: `No`
- User Property: `wildfly.authConfig`
- Alias: `authentication-config`

#### <commands>

The CLI commands to execute before the deployment is deployed.

- Type: `java.util.List<java.lang.String>`
- Required: `No`
- User Property: `wildfly.commands`

#### <debug>

Starts the server with debugging enabled.

- Type: `boolean`
- Required: `No`
- User Property: `wildfly.debug`
- Default: `false`

#### <debugHost>

Sets the hostname to listen on for debugging. An `*` means all hosts.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.debug.host`
- Default: `*`

#### <debugPort>

Sets the port the debugger should listen on.

- Type: `int`
- Required: `No`
- User Property: `wildfly.debug.port`
- Default: `8787`

#### <debugSuspend>

Indicates whether the server should suspend itself until a debugger is attached.

- Type: `boolean`
- Required: `No`
- User Property: `wildfly.debug.suspend`
- Default: `false`

#### <env>

Specifies the environment variables to be passed to the process being started.

    <env>
        <HOME>/home/wildfly/</HOME>
    </env>

- Type: `java.util.Map<java.lang.String, java.lang.String>`
- Required: `No`

#### <featurePackLocation>

The feature pack location. See the documentation for details on how to format a feature pack location.

Note that if you define the version in the feature pack location, e.g. `#26.1.1.Final`, the `version` configuration parameter should be left blank.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.feature-pack.location`
- Alias: `feature-pack-location`

#### <filename>

The file name of the application to be deployed.

The `filename` property does have a default of `${project.build.finalName}.${project.packaging}`. The default value is not injected as it normally would be due to packaging types like `ejb` that result in a file with a `.jar` extension rather than an `.ejb` extension.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.deployment.filename`

#### <hostname>

Specifies the host name of the server where the deployment plan should be executed.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.hostname`
- Default: `localhost`

#### <id>

Specifies the id of the server if the username and password is to be retrieved from the settings.xml file

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.id`

#### <javaHome>

The `JAVA_HOME` to use for launching the server.

- Type: `java.lang.String`
- Required: `No`
- User Property: `java.home`
- Alias: `java-home`

#### <javaOpts>

The JVM options to use.

- Type: `java.lang.String[]`
- Required: `No`
- User Property: `wildfly.javaOpts`
- Alias: `java-opts`

#### <jbossHome>

The WildFly Application Server's home directory. If not used, WildFly will be downloaded.

- Type: `java.lang.String`
- Required: `No`
- User Property: `jboss-as.home`
- Alias: `jboss-home`

#### <moduleOptions>

Options passed to JBoss Modules. This is useful for things like Java Agents where you need to start the server with an agent.

- Type: `java.lang.String[]`
- Required: `No`
- User Property: `wildfly.moduleOptions`
- Alias: `module-options`

#### <modulesPath>

The modules path or paths to use. A single path can be used or multiple paths by enclosing them in a paths element.

- Type: `org.wildfly.plugin.server.ModulesPath`
- Required: `No`
- User Property: `wildfly.modulesPath`
- Alias: `modules-path`

#### <name>

Specifies the name used for the deployment.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.deployment.name`

#### <password>

Specifies the password to use if prompted to authenticate by the server.

If no password is specified and the server requests authentication the user will be prompted to supply the password,

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.password`

#### <port>

Specifies the port number the server is listening on.

- Type: `int`
- Required: `No`
- User Property: `wildfly.port`
- Default: `9990`

#### <propertiesFile>

The path to the system properties file to load.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.propertiesFile`
- Alias: `properties-file`

#### <protocol>

The protocol used to connect to the server for management.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.protocol`

#### <provisioningDir>

The directory name inside the buildDir where to provision the default server. By default the server is provisioned into the 'server' directory.

- Type: `java.lang.String`
- Since: `3.0`
- Required: `No`
- User Property: `wildfly.provisioning.dir`
- Default: `server`
- Alias: `provisioning-dir`

#### <runtimeName>

The runtime name for the deployment.

In some cases users may wish to have two deployments with the same `runtime-name` (e.g. two versions of `example.war`) both available in the management configuration, in which case the deployments would need to have distinct `name` values but would have the same `runtime-name`.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.deployment.runtime.name`
- Alias: `runtime-name`

#### <scripts>

The CLI script files to execute before the deployment is deployed.

- Type: `java.util.List<java.io.File>`
- Required: `No`
- User Property: `wildfly.scripts`

#### <serverArgs>

The arguments to be passed to the server.

- Type: `java.lang.String[]`
- Required: `No`
- User Property: `wildfly.serverArgs`
- Alias: `server-args`

#### <serverConfig>

The path to the server configuration to use.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.serverConfig`
- Alias: `server-config`

#### <skip>

Set to `true` if you want to skip this goal, otherwise `false`.

- Type: `boolean`
- Required: `No`
- User Property: `wildfly.skip`
- Default: `false`

#### <startupTimeout>

The timeout value to use when starting the server.

- Type: `long`
- Required: `No`
- User Property: `wildfly.startupTimeout`
- Default: `60`
- Alias: `startup-timeout`

#### <timeout>

The timeout, in seconds, to wait for a management connection.

- Type: `int`
- Required: `No`
- User Property: `wildfly.timeout`
- Default: `60`

#### <username>

Specifies the username to use if prompted to authenticate by the server.

If no username is specified and the server requests authentication the user will be prompted to supply the username,

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.username`

#### <version>

The version of the WildFly default server to install in case no jboss-home has been set and no server has previously been provisioned.

The latest stable version is resolved if left blank.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.version`